#ifndef CORRESPEDIT_H
#define CORRESPEDIT_H

#include "generatedfiles/ui_CorrespEdit.h"
#include "ParamSelect.h"

enum CorrespEditSignals {
	COLORMAP_RANGE_MIN = 1,
	COLORMAP_RANGE_MAX,
	NUMBER_SAMPLES_SOURCE,
	NUMBER_SAMPLES_TARGET,
	FEATURE_SPACE_RANGE,
	FEATURE_SPACE_THRESHOLD,
	FEATURE_SPACE_MAX_MATCHES,
	MEAN_SHIFT_BANDWIDTH,
	MIN_CLUSTER_SIZE,
	MIN_VERIFY_REGION_SIZE,
	MAX_NUM_CLUSTERS,
	MAX_VERIFIED_REGIONS,
	CLUSTER_SELECT,
	MAX_PAIR_DISTANCE,
	COMPUTE_FEATURES,
	REFINE_CLUSTER,
	COMPUTE_TRANSFORMS,
	TRANSFORMS_SAVE,
	COMPUTE_MEAN_SHIFT,
	TRANSFORMS_VERIFY,
	GRAPH_CUT_RELABEL,
	SAMPLE_CORRESP,
	FEATURE_VIEWER
};

class CorrespEdit : public QWidget
{
	Q_OBJECT

public:
	CorrespEdit(QWidget *parent = 0);
	~CorrespEdit();

	void initRange( int which, double minRange, double maxRange, double initValue );

private slots:
	void on_FeatureViewerButton_clicked();
	void on_SampleCorrespButton_clicked();
	void on_GraphCutRelabelButton_clicked();
	void on_RefineClusterButton_clicked();
	void on_VerifyTransformationsButton_clicked();
	void on_SaveTransformsButton_clicked();
	void on_ComputeTransformsButton_clicked();
	void on_ComputeMeanShiftButton_clicked();
	void on_ComputeFeaturesButton_clicked();
	void controlChanged(int id, double value);

private:
	Ui::CorrespEditClass ui;
	std::vector<ParamSelect*> controls;

	void init();
	ParamSelect* findControl(int id);

signals:
	void valueChanged(int which, double value);
};


#endif // CORRESPEDIT_H
