#ifndef __FEATURE_VIEWER_H__
#define __FEATURE_VIEWER_H__

#include <QGLViewer/qglviewer.h>
#include <QMenu>
#include "types.h"

class Scene;
class PointListN;
class MatchCandidates;
class CorrespViewer;

class FeatureViewer : public QGLViewer {

	Q_OBJECT

public:
	FeatureViewer( Scene *sc );

	// Pointer for model selection
	CorrespViewer *correspViewer;

protected :
	virtual void draw();
	virtual void init();
	virtual void keyPressEvent(QKeyEvent *e);

private:

	Scene *scene;
	int shiftDim;
	bool showModes;

	//////////////////////////////////////////////////////////////////////////
	// Drawing functions
	void drawVerifiedTransforms();
	void drawFilteredClusterModes();
	void drawSelectedClusterModes();

	//////////////////////////////////////////////////////////////////////////
	// Menu variables and functions
	void createContextMenu();

	QMenu* contextMenu;
	QAction* showAllTransformsAct;
	QAction* showVerifiedTransformsAct;
	QAction* showFilteredClusterModesAct;
	QAction* showSelectedClusterModesAct;
};

#endif
