#ifndef __FILE_SEQUENCE_H__
#define __FILE_SEQUENCE_H__

#include <QString>
#include "types.h"

void splitPath( const QString &path, QString &dir, QString &file );		/**< Split a path to its immediate container and file. */
QString grabFile( const QString &path );
QString grabPath( const QString &path );
QString removeExt( const QString &filename );							/**< Remove the extension from the filename */

/**
 * Class for keeping a list of files.
 */
class FileSequence
{
public:
	// Various constructors
	FileSequence();
	FileSequence( QString filename );
	FileSequence( const char *filename );
	FileSequence( std::string filename );

	// Construction
	void construct( QString filename );

	// Access
	QString operator[]( index_type i ) const;
	QString operator[]( QString arg ) const;

	// Check
	bool hasNumber() const;
	bool valid() const;

	// Optional parameter storage
	int startFrame, endFrame, skipFrame;

private:

	// Data
	QString format;
	int numDigits;

};

#endif
