#ifndef __PARAM_SELECT_H__
#define __PARAM_SELECT_H__

#include <QtGui/QWidget>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>
#include <QtGui/QScrollBar>

class ParamSelect : public QWidget
{
	Q_OBJECT

public:
	ParamSelect( QWidget *ui, QString controlName, int id );

	int getId() const;
	void initRange( double minRange, double maxRange, double initValue );

	private slots:
		void minRangeClicked();
		void maxRangeClicked();
		void scrollChanged(int v);
		void editChanged();

private:
	QString name;
	const int paramId;
	QLabel *label;
	QPushButton *minRange, *maxRange;
	QScrollBar *scroll;
	QLineEdit *paramValue;

	// Parameter Value
	double minValue, maxValue, currentValue;

	QString doubleText( double x );
	void updateDisplay( bool updateScrollBar = true );

	// Workaround for emitting two signals when editing the value directly
	bool editingValue;

signals:
	void valueChanged( int id, double value );
};

#endif
