#include "subject.h"

//////////////////////////////////////////////////////////////////////////
// Implementation
//////////////////////////////////////////////////////////////////////////

Subject::Subject()
{
	_observers = new std::list<Observer*>;
}

Subject::~Subject()
{
	delete _observers;
}

void Subject::Attach(Observer* o) {
	_observers->push_back(o);
}

void Subject::Detach(Observer* o) {
	_observers->remove(o);
}

void Subject::Notify() {
	std::list<Observer*>::iterator i;

	for (i = _observers->begin(); i != _observers->end(); i++) {
		(*i)->Update(this);
	}
}
